module small_functions

!*************************************************************************************************************************

! Copyright  2003 S. Boragan Aruoba, Jesus Fernandez-Villaverde and Juan F. Rubio-Ramirez.

! This code is available on the World Wide Web at http://www.econ.upenn.edu/~jesusfv 
! and it is a part of the package prepared for the paper "Comparing Solution Methods for Dynamic Equilibrium Economies". 

! It may be freely reproduced for educational and research purposes, so long as it is not altered,
! this copyright notice is reproduced with it, and it is not sold for profit.

! Consent of the corresponding author (jesusfv@econ.upenn.edu) must be obtained before using all or any part of this code
! in a publication. 

! This version			: July 5, 2003

!************************************************************************************************************************	

	implicit none

	contains

function kron_tensor(x,y,x1,x2,y1,y2)

	implicit none

	integer x1,x2,y1,y2			! Dimensions of a x and y
	real(8), dimension(x1,x2) :: x	! first matrix
	real(8), dimension(y1,y2) :: y ! second matrix
	real(8), dimension(x1*y1,x2*y2) :: kron_tensor  ! Result
	integer i,j

	do i = 1,x1
		do j = 1,x2

		kron_tensor( ((i-1) * y1) + 1 : (i * y1), &
		   ((j-1) * y2) + 1 : (j * y2)  ) =  x(i,j) * y

		end do
	end do

end function kron_tensor

end module